## qtcreator 8.0.1

=== debian/changelog ===
qtcreator (8.0.1-1build1) kinetic; urgency=medium

  * No change rebuild against qt6-base-abi = (6.3.1)

 -- Rik Mills <rikmills@kde.org>  Fri, 19 Aug 2022 14:54:29 +0100

qtcreator (8.0.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Thu, 11 Aug 2022 21:13:30 +0200

qtcreator (8.0.0-3) unstable; urgency=medium

  * Team upload.
  * Add the qml6-module-qtqml-workerscript, and qml6-module-qtquick-layouts
    dependencies, needed in various QML sources; also add qt6-qpa-plugins,
    needed for the XCB base plugin. (Closes: #1016210)
  * Switch the qmlscene-qt6 recommend to qml-qt6, as that is actually what
    qtcreator uses when using Qt6.

 -- Pino Toscano <pino@debian.org>  Sat, 30 Jul 2022 08:06:55 +0200

qtcreator (8.0.0-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Fri, 29 Jul 2022 05:55:19 +0200

qtcreator (8.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Switch watch file back to stable releases.

 -- Pino Toscano <pino@debian.org>  Wed, 20 Jul 2022 19:04:38 +0200

qtcreator (8.0.0~rc1-2) experimental; urgency=medium

  * Team upload.
  * Pass --low-mem-die-limit 3000000 to dwz on some architectures (currently:
    armel armhf mipsel), as an attempt to complete the dwz processing without
    running into "out of memory" failures.

 -- Pino Toscano <pino@debian.org>  Fri, 08 Jul 2022 07:05:58 +0200

qtcreator (8.0.0~rc1-1) experimental; urgency=medium

  * Team upload.
  * New upstream development release.

 -- Pino Toscano <pino@debian.org>  Thu, 07 Jul 2022 20:31:08 +0200

qtcreator (8.0.0~beta2-1) experimental; urgency=medium

  * Team upload.
  * New upstream development release.
  * Update the build dependencies according to the upstream build system:
    - drop libicu-dev, no more used for many releases already
    - drop liblitehtml-dev, as the system version is not enough to replace the
      embedded copy
    - drop zlib1g-dev, not directly used
    - explicitly add python3, used during the build
  * Use a qtcreator-data.docs file to install the upstream changelog files,
    rather than passing all of them as arguments to dh_installdocs.
  * Limit the search of 'qmldir' files only to those executable, and make the
    chmod call verbose so it is easier to see whether there are any.

 -- Pino Toscano <pino@debian.org>  Tue, 28 Jun 2022 21:04:42 +0200

qtcreator (8.0.0~beta1-1) experimental; urgency=medium

  * Team upload.
  * New upstream development release.
  * Switch watch file to the unstable releases, mangling -beta/-rc in the
    version.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update the patches:
    - upstream_Correctly-include-KSyntaxHighlighting-headers.patch: drop,
      backported from upstream
    - debian_paths.diff: refresh
  * Switch qtcreator to build with Qt6 instead of Qt5:
    - remove libkf5syntaxhighlighting-dev, libqt5opengl5-dev,
      libqt5serialport5-dev, libqt5sql5-sqlite, libqt5svg5-dev,
      libqt5x11extras5-dev, qml-module-qtquick-controls, qml-module-qtquick2,
      qtbase5-dev, qtbase5-private-dev, qtdeclarative5-dev,
      qtdeclarative5-private-dev, qtscript5-dev, qttools5-dev,
      qttools5-dev-tools, and qttools5-private-dev
    - add libqt6core5compat6-dev, libqt6opengl6-dev, libqt6quicktimeline6-dev,
      libqt6serialport6-dev, libqt6shadertools6-dev, libqt6svg6-dev,
      qt6-base-dev, qt6-base-private-dev, qt6-declarative-dev,
      qt6-declarative-private-dev, qt6-quick3d-dev, qt6-tools-dev, and
      qt6-tools-private-dev
    - stop exporting QT_SELECT, no more needed
    - replace libqt5designercomponents5 with libqt6designercomponents6 in the
      strict dependency for Designer bits
    - update the runtime dependencies/recommends/suggests:
      - switch libqt5sql5-sqlite to libqt6sql6-sqlite
      - switch qml-module-qtqml-models2 to qml6-module-qtqml-models
      - switch qml-module-qtquick-controls to qml6-module-qtquick-controls
      - switch qml-module-qtquick2 to qml6-module-qtquick
      - drop qtchooser, no more needed with Qt6
      - switch qmlscene to qmlscene-qt6
      - drop qt5-doc, there is no Qt6 equivalent in Debian yet
      - switch qtbase5-dev-tools to qt6-base-dev-tools
      - switch qtdeclarative5-dev-tools to qt6-declarative-dev-tools
      - switch qttools5-dev-tools to qt6-tools-dev-tools
      - switch qttranslations5-l10n to qt6-translations-l10n
    - remove the license files installed from the embedded copy of
      KSyntaxHighlighting
    - the switch enables the build of the QML Designer plugin, which is built
      only when using Qt >= 6.2.0 (Closes: #1006555)
  * qtcreator now uses clangd instead of libclang for the Clang code model:
    - add clangd >= 14 as dependency: the unversioned name is used, and the
      current requirement is 14+
    - stop depending on the version of clang-N used by the unversioned clang,
      as there is no more need for the exact Clang version to locale the Clang
      includes
    - add the same clangd version also as build dependency: while it is not
      needed at build time, it makes sure that qtcreator can be built only when
      the runtime clangd requirement is satisfied

 -- Pino Toscano <pino@debian.org>  Fri, 17 Jun 2022 20:16:14 +0200

qtcreator (7.0.2-2) unstable; urgency=medium

  * Team upload.
  * Backport part of upstream commit 4d9215e44d70c10be2c183592e8280c4d7292a83
    to fix the includes of KSyntaxHighlighting, so they work also with 5.94.0+;
    patch upstream_Correctly-include-KSyntaxHighlighting-headers.patch.
  * Remove inactive Uploaders.

 -- Pino Toscano <pino@debian.org>  Mon, 30 May 2022 19:22:51 +0200

qtcreator (7.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.6.1, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 24 May 2022 20:05:21 +0200



=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
Build-Depends: clang (>= 1:10~),
               clangd (>= 1:14~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               libclang-dev (>= 1:10~),
               libdw-dev,
               libqt6core5compat6-dev,
               libqt6opengl6-dev,
               libqt6quicktimeline6-dev,
               libqt6serialport6-dev,
               libqt6shadertools6-dev (>= 6.2.4-2~),
               libqt6svg6-dev,
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:10~),
               pkg-config,
               python3:any,
               qt6-base-dev (>= 6.2.4+dfsg-3~),
               qt6-base-private-dev (>= 6.2.4+dfsg-3~),
               qt6-declarative-dev,
               qt6-declarative-private-dev,
               qt6-quick3d-dev (>= 6.2.4-2~),
               qt6-tools-dev (>= 6.2.4-2~),
               qt6-tools-private-dev (>= 6.2.4-2~),
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator

Package: qtcreator
Architecture: any
Depends: clangd (>= 1:14~),
         libqt6sql6-sqlite,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick,
         qt6-qpa-plugins,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qml-qt6,
            qt6-qmltooling-plugins,
            qt6-base-dev-tools,
            qtcreator-doc,
            qt6-declarative-dev-tools,
            qt6-tools-dev-tools,
            qt6-translations-l10n,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind,
          python3-pylsp,
Breaks: qtcreator-data (<< 4.5.2-2~)
Replaces: qtcreator-data (<< 4.5.2-2~)
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

# Do not build the HelloWorld plugin, as it is not needed
export QTC_BUILD_PLUGIN_HELLOWORLD=FALSE

# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')

# the dwz processing for all the libraries and plugins can take a lot of memory,
# which may be not enough on some architectures (typically 32bit), resulting in
# dwz failing with "Could not allocate memory: Cannot allocate memory" errors;
# hence, on architectures where we see this result, try to use a more memory
# friendly processing for a lower number of DIEs (dwz default is 10M)
archs_with_dwz_low_mem = armel armhf mipsel
dwz_low_mem = 3000000

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_DEVELOPER_DOCS=ON \
		-DBUILD_QBS=OFF \
		-DWITH_TESTS=OFF \
		-DBUILD_TESTING=OFF \
		-DCLANGTOOLING_LINK_CLANG_DYLIB=ON \
		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF)

execute_after_dh_auto_build-indep:
	dh_auto_build -- docs

execute_after_dh_auto_install:
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component qch_docs
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component html_docs
endif

	# Not needed
	rm debian/tmp/usr/bin/qtcreator.sh

	# License files of the embedded copy of KSyntaxHighlighting
	rm -rf debian/tmp/usr/share/qtcreator/generic-highlighter/syntax/licenses/

	# Remove extra exec permissions
	find debian/tmp -name qmldir -type f -perm /111 -exec chmod -v -x {} \;

execute_after_dh_install:
	# Copied in qtcreator-doc already
	rm -rf debian/qtcreator-data/usr/share/qtcreator/doc/

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/

override_dh_shlibdeps:
	echo 'libQt6DesignerComponents 6 libqt6designercomponents6 (>= $(call upstream_version_of_pkg,libqt6designercomponents6)~)' > debian/shlibs.local
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator
	rm debian/shlibs.local

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_with_dwz_low_mem)))
override_dh_dwz:
	dh_dwz -- --low-mem-die-limit $(dwz_low_mem)
endif

## qtcreator 9.0.1

=== debian/changelog ===
qtcreator (9.0.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Thu, 15 Dec 2022 23:12:28 +0100

qtcreator (9.0.0-4) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Thu, 01 Dec 2022 06:22:59 +0100

qtcreator (9.0.0-3) experimental; urgency=medium

  * Team upload.
  * When building with clang, force the v4 of the DWARF info: apparently the
    DWARF v5 that clang produces are not fully supported by dwz (see also
    #1016936):
    - append -gdwarf-4 to CFLAGS and CXXFLAGS

 -- Pino Toscano <pino@debian.org>  Mon, 28 Nov 2022 20:51:55 +0100

qtcreator (9.0.0-2) experimental; urgency=medium

  * Team upload.
  * Merge changes from 8.0.2-1.
  * Build using clang on mips64el, and mipsel, to workaround a GCC bug:
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=102602
    - point CC & CXX to clang
    - restore explicit as-needed linking, as it seems needed when using clang
    - disable the build with precompiled headers (PCH), as it is not working

 -- Pino Toscano <pino@debian.org>  Sun, 27 Nov 2022 13:53:28 +0100

qtcreator (9.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Switch watch file back to stable releases.

 -- Pino Toscano <pino@debian.org>  Thu, 24 Nov 2022 22:05:01 +0100

qtcreator (9.0.0~rc1-1) experimental; urgency=medium

  * Team upload.
  * New upstream development release.
  * Add the qt6-image-formats-plugins dependency to qtcreator-doc: some of the
    images are in webp format, and qt6-image-formats-plugins contains the Qt
    plugin to open them.

 -- Pino Toscano <pino@debian.org>  Sat, 12 Nov 2022 10:08:36 +0100

qtcreator (9.0.0~beta2-1) experimental; urgency=medium

  * Team upload.
  * New upstream development release.
  * Switch watch file to the unstable releases.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update the build dependencies according to the upstream build system:
    - bump all the Qt packages to 6.2, in case they did not have a version set
      already
  * Stop shipping the upstream changelogs in /usr/share/doc/qtcreator-data/,
    as upstream now installs them in /usr/share/qtcreator/changelog/, and they
    can be opened from the Help menu.

 -- Pino Toscano <pino@debian.org>  Sun, 30 Oct 2022 07:53:39 +0100

qtcreator (8.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop the qt6-qpa-plugins dependency, as the Qt6 6.3.1 packaging provides
    all the essential bits in library packages.
  * Remove breaks/replaces for versions older than oldstable.
  * Temporarily add the clang-tidy, and clang-tools build dependencies to
    workaround the broken CMake config files shipped in llvm-14-dev (which is
    the current version pulled by llvm-dev): it is still affected by #1021857,
    and the LLVM maintainers have not fixed it in testing for almost 2 months.

 -- Pino Toscano <pino@debian.org>  Sat, 26 Nov 2022 08:30:01 +0100

=== debian/control ===
--- 
+++ 
@@ -10,12 +10,12 @@
                debhelper-compat (= 13),
                libclang-dev (>= 1:10~),
                libdw-dev,
-               libqt6core5compat6-dev,
-               libqt6opengl6-dev,
-               libqt6quicktimeline6-dev,
-               libqt6serialport6-dev,
+               libqt6core5compat6-dev (>= 6.2~),
+               libqt6opengl6-dev (>= 6.2~),
+               libqt6quicktimeline6-dev (>= 6.2~),
+               libqt6serialport6-dev (>= 6.2~),
                libqt6shadertools6-dev (>= 6.2.4-2~),
-               libqt6svg6-dev,
+               libqt6svg6-dev (>= 6.2~),
                libyaml-cpp-dev (>= 0.5~),
                libzstd-dev,
                llvm-dev (>= 1:10~),
@@ -23,11 +23,14 @@
                python3:any,
                qt6-base-dev (>= 6.2.4+dfsg-3~),
                qt6-base-private-dev (>= 6.2.4+dfsg-3~),
-               qt6-declarative-dev,
-               qt6-declarative-private-dev,
+               qt6-declarative-dev (>= 6.2~),
+               qt6-declarative-private-dev (>= 6.2~),
                qt6-quick3d-dev (>= 6.2.4-2~),
                qt6-tools-dev (>= 6.2.4-2~),
                qt6-tools-private-dev (>= 6.2.4-2~),
+# workaround dependency issues in llvm (#1021857)
+               clang-tidy,
+               clang-tools,
 Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://doc.qt.io/qt-5/topics-app-development.html
@@ -43,7 +46,6 @@
          qml6-module-qtquick-controls,
          qml6-module-qtquick-layouts,
          qml6-module-qtquick,
-         qt6-qpa-plugins,
          qtcreator-data (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
@@ -60,8 +62,6 @@
             xterm | x-terminal-emulator
 Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind,
           python3-pylsp,
-Breaks: qtcreator-data (<< 4.5.2-2~)
-Replaces: qtcreator-data (<< 4.5.2-2~)
 Description: integrated development environment (IDE) for Qt
  Qt Creator is a cross-platform integrated development environment (IDE)
  designed to make development with the Qt application framework faster
@@ -88,7 +88,8 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends}
+Depends: qt6-image-formats-plugins,
+         ${misc:Depends},
 Description: documentation for Qt Creator IDE
  Qt Creator is a cross-platform integrated development environment (IDE)
  designed to make development with the Qt application framework faster

## qtcreator 9.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

## Add paths to check for cmake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(Utils)

env_with_default("QTC_BUILD_WITH_PCH" ENV_QTC_BUILD_WITH_PCH ON)
env_with_default("QTC_WITH_TESTS" ENV_QTC_WITH_TESTS OFF)

option(BUILD_WITH_PCH "Build with precompiled headers" "${ENV_QTC_BUILD_WITH_PCH}")

include(FeatureSummary)
include(QtCreatorIDEBranding RESULT_VARIABLE IDE_BRANDING_FILE)
include(QtCreatorTranslations)
include(QtCreatorDocumentation)
include(QtCreatorAPI)

set(IDE_REVISION FALSE CACHE BOOL "Marks the presence of IDE revision string.")
set(IDE_REVISION_STR "" CACHE STRING "The IDE revision string.")
set(IDE_REVISION_URL "" CACHE STRING "The IDE revision Url string.")

mark_as_advanced(IDE_REVISION IDE_REVISION_STR IDE_REVISION_URL)

project(QtCreator VERSION ${IDE_VERSION})

# Force C++ standard, do not fall back, do not use compiler extensions
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

qtc_handle_compiler_cache_support()

option(BUILD_LINK_WITH_QT "Link with Qt from the parent Qt Creator" OFF)
qtc_link_with_qt()

option(WITH_TESTS "Build Tests" ${ENV_QTC_WITH_TESTS})
add_feature_info("Build tests" ${WITH_TESTS} "")
option(WITH_DEBUG_CMAKE "Enabled CMake project debugging functionality" OFF)
option(SHOW_BUILD_DATE "Show build date in about dialog" OFF)
option(WITH_SANITIZE "Build with sanitizer enabled" OFF)
set(SANITIZE_FLAGS "" CACHE STRING "Sets flags for sanitizer compilation flags used in Debug builds")
add_feature_info("Build with sanitize" ${WITH_SANITIZE} "SANITIZE_FLAGS='${SANITIZE_FLAGS}'")


# merge binary directories of sub projects into top level
set(QTC_MERGE_BINARY_DIR ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set up Qt stuff:
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if (WITH_TESTS)
  set(QT_TEST_COMPONENT Test)
  set(IMPLICIT_DEPENDS Qt5::Test)
endif()

# suppress bogus warning
# warning C4573 requires the compiler to capture 'this' but the current default capture mode does not allow it
# when using QObject::connect in lambda without capturing 'this' - which would lead to warnings
# with other compilers
if(MSVC)
  add_compile_options(/wd4573)
endif()

find_package(Qt5
  ${IDE_QT_VERSION_MIN}
  COMPONENTS Concurrent Core Gui Network PrintSupport Qml Sql Widgets Xml Core5Compat ${QT_TEST_COMPONENT}
  REQUIRED
)
if (Qt5_VERSION VERSION_LESS 6.0.0)
  install(TARGETS Qt6Core5Compat EXPORT QtCreator)

  # Specify standards conformance mode to MSVC 2017 and later
  # Qt6 has the values as part of the Qt6::Platform target interface
  if (MSVC AND MSVC_VERSION GREATER_EQUAL 1910)
    add_compile_options(/permissive- /Zc:__cplusplus)
  endif()
  if (CMAKE_CXX_COMPILER_ID STREQUAL GNU)
    add_compile_options(-Wno-missing-field-initializers)
  endif()
else()
  # Common intermediate directory for QML modules which are defined via qt_add_qml_module()
  set(QT_QML_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/qml_modules")

  # This includes the code that will enable higher compiler warnings level (/W3 for MSVC, -Wall -Wextra for GCC)
  # This is controlled by QT_COMPILE_OPTIONS_DISABLE_WARNINGS target property.
  include(QtCompilerFlags)

  if (MSVC AND QT_FEATURE_static_runtime)
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
  endif()
endif()
find_package(Qt5 COMPONENTS LinguistTools QUIET)
find_package(Qt5 COMPONENTS Quick QuickWidgets Designer DesignerComponents Help SerialPort Svg Tools QUIET)

find_package(Threads)
find_package(Clang QUIET)
if (Qt5_VERSION VERSION_LESS 6.0.0)
  find_package(KF5SyntaxHighlighting QUIET)
endif()

# Crashpad
set(CRASHPAD_BACKEND_URL "" CACHE STRING "Crashpad backend URL")
set(BUILD_WITH_CRASHPAD OFF)
# Linux is not supported for now
# x86_64;arm64 is not supported for now
if(CRASHPAD_BACKEND_URL AND (WIN32 OR APPLE)) # Linux is not supported for now
  find_package(Crashpad QUIET)
  if(TARGET Crashpad::Crashpad)
    set(BUILD_WITH_CRASHPAD ON)
  endif()
endif()
add_feature_info("Build with Crashpad" ${BUILD_WITH_CRASHPAD} "")

function (set_if_target var target)
   if (TARGET "${target}")
     set(_result ON)
   else()
     set(_result OFF)
   endif()
   set(${var} "${_result}" PARENT_SCOPE)
endfunction()

set_if_target(_has_svg_target Qt5::Svg)
option(ENABLE_SVG_SUPPORT "Enable SVG support" "${_has_svg_target}")

add_library(OptionalSvg INTERFACE)
if (TARGET Qt5::Svg AND ENABLE_SVG_SUPPORT)
  target_link_libraries(OptionalSvg INTERFACE Qt5::Svg)
else()
  target_compile_definitions(OptionalSvg INTERFACE QT_NO_SVG)
endif()
install(TARGETS OptionalSvg EXPORT QtCreator)

if (APPLE)
  find_library(FWCoreFoundation CoreFoundation)
  find_library(FWCoreServices CoreServices)
  find_library(FWFoundation Foundation)
  find_library(FWAppKit AppKit)
  find_library(FWIOKit IOKit)
  find_library(FWSecurity Security)
  find_library(FWSystemConfiguration SystemConfiguration)
  find_library(FWWebKit WebKit)
endif()

if (WITH_TESTS)
  enable_testing()
endif()

if (UNIX)
  add_subdirectory(bin)
endif()

add_subdirectory(src)
add_subdirectory(share)
add_subdirectory(dist)

if (WITH_TESTS)
  add_subdirectory(tests)
endif()

add_subdirectory(doc)

setup_dependencies_component()

feature_summary(INCLUDE_QUIET_PACKAGES WHAT
  PACKAGES_FOUND PACKAGES_NOT_FOUND
  ENABLED_FEATURES DISABLED_FEATURES
)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR
    AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.GPL3-EXCEPT")
  # Only for opensource, non-super-repo builds
  add_subdirectory(packaging)
endif()

=== src/app/CMakeLists.txt ===
configure_file(app_version.h.cmakein app_version.h ESCAPE_QUOTES)

if(NOT IS_ABSOLUTE "${IDE_ICON_PATH}")
  set(IDE_ICON_PATH "${CMAKE_CURRENT_SOURCE_DIR}/${IDE_ICON_PATH}")
endif()

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/app_version.h
  DESTINATION ${IDE_HEADER_INSTALL_PATH}/src/app
  COMPONENT Devel EXCLUDE_FROM_ALL
)

add_qtc_executable(qtcreator
  DEFINES IDE_LIBRARY_BASENAME=\"${IDE_LIBRARY_BASE_PATH}\"
  DEPENDS Aggregation ExtensionSystem Qt5::Core Qt5::Widgets Utils shared_qtsingleapplication app_version
  SOURCES
    main.cpp
    ../tools/qtcreatorcrashhandler/crashhandlersetup.cpp ../tools/qtcreatorcrashhandler/crashhandlersetup.h
  PROPERTIES
    WIN32_EXECUTABLE ON
    MACOSX_BUNDLE ON
    OUTPUT_NAME "${IDE_APP_TARGET}"
  DESTINATION "${IDE_APP_PATH}"
  QTC_RUNNABLE
)

extend_qtc_executable(qtcreator
  CONDITION APPLE
  DEPENDS ${FWFoundation}
  SOURCES
    main_mac.mm
)

if (NOT TARGET qtcreator)
  return()
endif()

if (QTC_STATIC_BUILD)
  set(plugins_to_import "")
  set(source_file_content "#include <QtPlugin>\n")
  foreach(plugin IN LISTS __QTC_PLUGINS)
    if(TARGET ${plugin})
      list(APPEND plugins_to_import "${plugin}")
      # TODO ${plugin}Plugin is not correct for all plugins as the class name
      get_target_property(plugin_class ${plugin} QTC_PLUGIN_CLASS_NAME)
      string(APPEND source_file_content "Q_IMPORT_PLUGIN(${plugin_class})\n")
    endif()
  endforeach()

  string(APPEND source_file_content
    "struct ResourcesInitializer {\n"
    "  ResourcesInitializer() {\n")
  foreach(resource_file IN LISTS __QTC_RESOURCE_FILES)
     string(APPEND source_file_content "    Q_INIT_RESOURCE(${resource_file});\n")
  endforeach()
  string(APPEND source_file_content
    "  }\n"
    "} g_resources_initializer;\n")

  file(GENERATE
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/plugin_imports.cpp"
    CONTENT "${source_file_content}"
  )
  extend_qtc_target(qtcreator
    DEPENDS ${plugins_to_import}
    SOURCES "${CMAKE_CURRENT_BINARY_DIR}/plugin_imports.cpp"
  )

  if (Qt5_VERSION VERSION_GREATER_EQUAL 6.0.0 AND TARGET QmlDesigner)
    qt6_import_qml_plugins(qtcreator
      PATH_TO_SCAN "${CMAKE_CURRENT_SOURCE_DIR}/../../share/qtcreator/qmldesigner")
  endif()
endif()

if (WIN32)
  set(RC_APPLICATION_NAME "${IDE_DISPLAY_NAME}")
  set(RC_VERSION "${IDE_VERSION}.0")
  set(RC_VERSION_STRING "${IDE_VERSION_DISPLAY}")
  set(RC_COPYRIGHT "2008-${IDE_COPYRIGHT_YEAR} The Qt Company Ltd")

  string(REPLACE " " "\\x20" RC_APPLICATION_NAME "${RC_APPLICATION_NAME}")
  string(REPLACE " " "\\x20" RC_COPYRIGHT "${RC_COPYRIGHT}")
  string(REPLACE "." "," RC_VERSION "${RC_VERSION}")

  target_compile_definitions(qtcreator PRIVATE
    RC_APPLICATION_NAME=${RC_APPLICATION_NAME}
    RC_VERSION=${RC_VERSION}
    RC_VERSION_STRING=${RC_VERSION_STRING}
    RC_COPYRIGHT=${RC_COPYRIGHT}
    RC_ICON_PATH=${IDE_ICON_PATH}
  )

  target_sources(qtcreator PRIVATE qtcreator.rc)
endif()

if (APPLE)
  if (CMAKE_OSX_DEPLOYMENT_TARGET)
    set(MACOSX_DEPLOYMENT_TARGET ${CMAKE_OSX_DEPLOYMENT_TARGET})
  endif()
  set_target_properties(qtcreator PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/app-Info.plist"
  )
  # icon
  add_custom_command(
    OUTPUT qtcreator.icns qtcreator-project.icns
    COMMAND
      xcrun actool --app-icon qtcreator --output-partial-info-plist "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.Info.plist"
      --platform macosx --minimum-deployment-target 10.7 --compile "${CMAKE_CURRENT_BINARY_DIR}"
      "${IDE_ICON_PATH}/qtcreator.xcassets"
      > /dev/null
    BYPRODUCTS qtcreator.Info.plist
    VERBATIM
  )
  target_sources(qtcreator
    PRIVATE
      "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns"
      "${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns"
  )
  qtc_copy_to_builddir(copy_icns
    DESTINATION ${IDE_DATA_PATH}
    FILES
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns
  )
  install(
    FILES
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns
    DESTINATION ${IDE_DATA_PATH}
  )
endif()

option(QTC_FORCE_XCB "Enables that Qt Creator forces XCB on Linux if QT_QPA_PLATFORM is not set." OFF)
extend_qtc_executable(qtcreator
  CONDITION QTC_FORCE_XCB
  DEFINES
    QTC_FORCE_XCB
)

extend_qtc_executable(qtcreator
  CONDITION BUILD_WITH_CRASHPAD
  DEFINES
    CRASHPAD_BACKEND_URL="${CRASHPAD_BACKEND_URL}"
    ENABLE_CRASHPAD
    WIN32_LEAN_AND_MEAN # It comes usually with precompiled header, but at the installer they are disabled
  DEPENDS Crashpad::Crashpad
)
if(BUILD_WITH_CRASHPAD)
  install(
    PROGRAMS ${CRASHPAD_BIN_DIR}/crashpad_handler${CMAKE_EXECUTABLE_SUFFIX}
    DESTINATION "${IDE_LIBEXEC_PATH}"
  )
endif()

=== src/libs/CMakeLists.txt ===
add_subdirectory(3rdparty)

add_subdirectory(advanceddockingsystem)
add_subdirectory(aggregation)
add_subdirectory(extensionsystem)
add_subdirectory(utils)
add_subdirectory(languageutils)
add_subdirectory(cplusplus)
add_subdirectory(modelinglib)
add_subdirectory(nanotrace)
add_subdirectory(qmljs)
add_subdirectory(qmldebug)
add_subdirectory(qmleditorwidgets)
add_subdirectory(glsl)
add_subdirectory(languageserverprotocol)
add_subdirectory(sqlite)
add_subdirectory(tracing)

add_subdirectory(qtcreatorcdbext)

if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/qlitehtml/src/CMakeLists.txt)
  option(BUILD_LIBRARY_QLITEHTML "Build library qlitehtml." ${BUILD_LIBRARIES_BY_DEFAULT})
  set(QLITEHTML_VERSION_COMPAT ${IDE_VERSION_COMPAT} CACHE STRING "")
  if(BUILD_LIBRARY_QLITEHTML)
    set(QLITEHTML_LIBRARY_ARCHIVE_PATH ${IDE_LIBRARY_ARCHIVE_PATH})
    set(QLITEHTML_EXPORT QtCreator)
    set(QLITEHTML_DEVEL_COMPONENT Devel)
    set(QLITEHTML_DEVEL_EXCLUDE_FROM_ALL ON)
    set(QLITEHTML_HEADER_PATH "${IDE_HEADER_INSTALL_PATH}/src/lib/qlitehtml")
    if (QTC_STATIC_BUILD)
      set(QLITEHTML_LIBRARY_TYPE STATIC)
    else()
      set(QLITEHTML_BIN_PATH ${IDE_BIN_PATH})
      set(QLITEHTML_LIBRARY_PATH ${IDE_LIBRARY_PATH})
    endif()
    set(QT_VERSION_MAJOR ${Qt5_VERSION_MAJOR})
    option(BUILD_TESTING "Build litehtml tests" OFF) # otherwise litehtml downloads googletest
    add_subdirectory(qlitehtml/src)
  endif()
  if(TARGET qlitehtml)
    target_compile_definitions(qlitehtml PRIVATE ${DEFAULT_DEFINES}) # for precompiled headers
    enable_pch(qlitehtml)
    #doesn't work: TARGET 'qlitehtml' was not created in this directory.
    #qtc_enable_separate_debug_info(qlitehtml "${IDE_LIBRARY_PATH}")
    qtc_output_binary_dir(_output_binary_dir)
    set_target_properties(qlitehtml PROPERTIES
      BUILD_RPATH "${_LIB_RPATH};${CMAKE_BUILD_RPATH}"
      INSTALL_RPATH "${_LIB_RPATH};${CMAKE_INSTALL_RPATH}"
      RUNTIME_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_BIN_PATH}"
      LIBRARY_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_LIBRARY_PATH}"
      ARCHIVE_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_LIBRARY_ARCHIVE_PATH}"
    )
  endif()
endif()

=== src/tools/CMakeLists.txt ===
add_subdirectory(3rdparty)
add_subdirectory(buildoutputparser)

option(BUILD_CPLUSPLUS_TOOLS "Build CPlusPlus tools" OFF)

function(add_qtc_cpp_tool name)
  add_qtc_executable(${name}
    DEFINES
      PATH_PREPROCESSOR_CONFIG=\"${CMAKE_CURRENT_SOURCE_DIR}/cplusplus-shared/pp-configuration.inc\"
      ${ARGN}
    DEPENDS CPlusPlus Utils Qt5::Widgets
    INCLUDES "${CMAKE_CURRENT_SOURCE_DIR}/cplusplus-shared"
      "${CMAKE_CURRENT_SOURCE_DIR}/${name}"
    SOURCES
      cplusplus-shared/utils.cpp
      "${name}/${name}.cpp"
  )
endfunction()

if (BUILD_CPLUSPLUS_TOOLS)
  add_qtc_cpp_tool(cplusplus-ast2png "")
  add_qtc_cpp_tool(cplusplus-frontend "")
  add_qtc_cpp_tool(cplusplus-mkvisitor PATH_AST_H=\"${CMAKE_CURRENT_SOURCE_DIR}/../libs/3rdparty/cplusplus/AST.h\")
  add_qtc_cpp_tool(cplusplus-update-frontend PATH_CPP_FRONTEND=\"${CMAKE_CURRENT_SOURCE_DIR}/../libs/3rdparty/cplusplus\" PATH_DUMPERS_FILE=\"${CMAKE_CURRENT_SOURCE_DIR}/cplusplus-ast2png/dumpers.inc\")
endif()

if (APPLE)
  add_subdirectory(disclaim)
  add_subdirectory(iostool)
endif()

add_subdirectory(processlauncher)
add_subdirectory(qml2puppet)
add_subdirectory(qtcdebugger) ## windows only
# add_subdirectory(qtcrashhandler)
add_subdirectory(qtc-askpass)
add_subdirectory(qtcreatorcrashhandler)
# add_subdirectory(qtcreatorwidgets) ## qbs does not build this either
add_subdirectory(qtpromaker)
add_subdirectory(sdktool)
add_subdirectory(valgrindfake)
add_subdirectory(wininterrupt) ## windows only

if (EXISTS ${CMAKE_CURRENT_LIST_DIR}/perfparser/CMakeLists.txt)
  add_subdirectory(perfparser)
endif()

=== tests/manual/CMakeLists.txt ===
# add_subdirectory(autotoolsprojectmanager)
# add_subdirectory(clang-format-for-qtc)
# add_subdirectory(cplusplus-tools)
# add_subdirectory(cppquickfix)
add_subdirectory(debugger)
# add_subdirectory(distribution)
# add_subdirectory(dockwidgets)
add_subdirectory(fakevim)
# add_subdirectory(features)
# add_subdirectory(filesystemview)
# add_subdirectory(genericproject)
add_subdirectory(pluginview)
add_subdirectory(proparser)
# add_subdirectory(qml)
# add_subdirectory(qt4projectmanager)
# add_subdirectory(search)
add_subdirectory(shootout)
add_subdirectory(widgets)
add_subdirectory(deviceshell)

=== tests/unit/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

if (NOT QT_CREATOR_API_DEFINED)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../cmake")

  project(unit)

  enable_testing()

  # Needed for pch
  set(QtCreator_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../../")
  option(BUILD_WITH_PCH "Build with precompiled headers" ON)

  set(CMAKE_AUTOMOC ON)
  set(CMAKE_AUTORCC ON)
  set(CMAKE_AUTOUIC ON)

  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF)

  set(CMAKE_INCLUDE_CURRENT_DIR ON)

  set(IMPLICIT_DEPENDS Qt5::Test)

  include(QtCreatorIDEBranding)
  include(QtCreatorAPI)

  set(WITH_TESTS ON)
  set(GOOGLETEST_DIR ${CMAKE_CURRENT_LIST_DIR}/unittest/3rdparty/googletest)

  find_package(Clang MODULE)
  find_package(Qt5
    COMPONENTS
      Gui Core Core5Compat Widgets Network Qml Concurrent Test Xml MODULE)
  find_package(Threads)
endif()

add_subdirectory(unittest)

=== src/libs/advanceddockingsystem/CMakeLists.txt ===
add_qtc_library(AdvancedDockingSystem
  DEPENDS Qt5::Widgets Qt5::Core Qt5::Gui Utils
  SOURCES
    ads_globals.cpp ads_globals.h
    advanceddockingsystemtr.h
    dockareatabbar.cpp dockareatabbar.h
    dockareatitlebar.cpp dockareatitlebar.h
    dockareawidget.cpp dockareawidget.h
    dockcomponentsfactory.cpp dockcomponentsfactory.h
    dockcontainerwidget.cpp dockcontainerwidget.h
    dockfocuscontroller.cpp dockfocuscontroller.h
    dockingstatereader.cpp dockingstatereader.h
    dockmanager.cpp dockmanager.h
    dockoverlay.cpp dockoverlay.h
    docksplitter.cpp docksplitter.h
    dockwidget.cpp dockwidget.h
    dockwidgettab.cpp dockwidgettab.h
    elidinglabel.cpp elidinglabel.h
    floatingdockcontainer.cpp floatingdockcontainer.h
    floatingdragpreview.cpp floatingdragpreview.h
    iconprovider.cpp iconprovider.h
    workspacedialog.cpp workspacedialog.h
    workspacemodel.cpp workspacemodel.h
    workspaceview.cpp workspaceview.h
    workspacedialog.ui
)

extend_qtc_library(AdvancedDockingSystem
  INCLUDES linux
  SOURCES
    linux/floatingwidgettitlebar.cpp linux/floatingwidgettitlebar.h
)

=== src/libs/extensionsystem/CMakeLists.txt ===
add_qtc_library(ExtensionSystem
  DEPENDS Aggregation Utils
  PUBLIC_DEPENDS Qt5::Core Qt5::Widgets
  SOURCES
    extensionsystem_global.h
    extensionsystemtr.h
    invoker.cpp invoker.h
    iplugin.cpp iplugin.h iplugin_p.h
    optionsparser.cpp optionsparser.h
    plugindetailsview.cpp plugindetailsview.h plugindetailsview.ui
    pluginerroroverview.cpp pluginerroroverview.h pluginerroroverview.ui
    pluginerrorview.cpp pluginerrorview.h pluginerrorview.ui
    pluginmanager.cpp pluginmanager.h pluginmanager_p.h
    pluginspec.cpp pluginspec.h pluginspec_p.h
    pluginview.cpp pluginview.h
  EXPLICIT_MOC
    pluginmanager.h
    pluginmanager_p.h
  SKIP_AUTOMOC pluginmanager.cpp
)

find_package(Qt5 COMPONENTS Test QUIET)

extend_qtc_library(ExtensionSystem
  CONDITION TARGET Qt5::Test
  DEPENDS Qt5::Test
  DEFINES WITH_TESTS
)

=== src/libs/languageserverprotocol/CMakeLists.txt ===
add_qtc_library(LanguageServerProtocol
  DEPENDS Utils
  SOURCES
    basemessage.cpp basemessage.h
    client.cpp client.h
    clientcapabilities.cpp clientcapabilities.h
    completion.cpp completion.h
    diagnostics.cpp diagnostics.h
    initializemessages.cpp initializemessages.h
    jsonkeys.h
    jsonobject.cpp jsonobject.h
    jsonrpcmessages.cpp jsonrpcmessages.h
    languagefeatures.cpp languagefeatures.h
    languageserverprotocol_global.h
    languageserverprotocoltr.h
    lsptypes.cpp lsptypes.h
    lsputils.cpp lsputils.h
    messages.cpp messages.h
    progresssupport.cpp progresssupport.h
    semantictokens.cpp semantictokens.h
    servercapabilities.cpp servercapabilities.h
    shutdownmessages.cpp shutdownmessages.h
    textsynchronization.cpp textsynchronization.h
    workspace.cpp workspace.h
)

=== src/libs/nanotrace/CMakeLists.txt ===

add_qtc_library(Nanotrace
    BUILD_DEFAULT OFF
    DEFINES NANOTRACE_LIBRARY
    PUBLIC_DEFINES NANOTRACE_ENABLED
    SOURCES nanotrace.cpp nanotrace.h
  PROPERTIES
    CXX_VISIBILITY_PRESET default
    VISIBILITY_INLINES_HIDDEN OFF
)

=== src/libs/tracing/CMakeLists.txt ===
if (WITH_TESTS)
  set(TEST_SOURCES
    runscenegraphtest.cpp runscenegraphtest.h
  )
else()
  set(TEST_SOURCES "")
endif()

set(TRACING_CPP_SOURCES
  flamegraph.cpp flamegraph.h
  flamegraphattached.h
  safecastable.h
  timelineabstractrenderer.cpp timelineabstractrenderer.h timelineabstractrenderer_p.h
  timelineformattime.cpp timelineformattime.h
  timelineitemsrenderpass.cpp timelineitemsrenderpass.h
  timelinemodel.cpp timelinemodel.h timelinemodel_p.h
  timelinemodelaggregator.cpp timelinemodelaggregator.h
  timelinenotesmodel.cpp timelinenotesmodel.h timelinenotesmodel_p.h
  timelinenotesrenderpass.cpp timelinenotesrenderpass.h
  timelineoverviewrenderer.cpp timelineoverviewrenderer.h timelineoverviewrenderer_p.h
  timelinerenderer.cpp timelinerenderer.h timelinerenderer_p.h
  timelinerenderpass.cpp timelinerenderpass.h
  timelinerenderstate.cpp timelinerenderstate.h timelinerenderstate_p.h
  timelineselectionrenderpass.cpp timelineselectionrenderpass.h
  timelinetheme.cpp timelinetheme.h
  timelinetracefile.cpp timelinetracefile.h
  timelinetracemanager.cpp timelinetracemanager.h
  timelinezoomcontrol.cpp timelinezoomcontrol.h
  traceevent.h
  traceeventtype.h
  tracestashfile.h
  tracing_global.h
  tracingtr.h
)

find_package(Qt6 COMPONENTS ShaderTools QUIET)

add_qtc_library(Tracing
  CONDITION TARGET Qt6::ShaderTools AND TARGET Qt5::Quick
  FEATURE_INFO
  DEPENDS Utils Qt5::Quick
  PUBLIC_DEPENDS Qt5::Widgets Qt5::Qml
  SOURCES
    ${TEST_SOURCES}
)

if (NOT TARGET Tracing)
  return()
endif()

set(TRACING_QML_FILES
  qml/ButtonsBar.qml
  qml/CategoryLabel.qml
  qml/Detail.qml
  qml/FlameGraphDelegate.qml
  qml/FlameGraphView.qml
  qml/ImageToolButton.qml
  qml/MainView.qml
  qml/Overview.qml
  qml/RangeDetails.qml
  qml/RangeMover.qml
  qml/RowLabel.qml
  qml/SelectionRange.qml
  qml/SelectionRangeDetails.qml
  qml/TimeDisplay.qml
  qml/TimelineContent.qml
  qml/TimelineLabels.qml
  qml/TimelineRulers.qml
  qml/TimelineText.qml
  qml/TimeMarks.qml
)

set(TRACING_QML_RESOURCES
  qml/ico_edit.png
  qml/ico_edit@2x.png
  qml/ico_rangeselected.png
  qml/ico_rangeselected@2x.png
  qml/ico_rangeselection.png
  qml/ico_rangeselection@2x.png
  qml/ico_selectionmode.png
  qml/ico_selectionmode@2x.png
  qml/range_handle.png
  qml/range_handle@2.png
)

foreach(file IN LISTS TRACING_QML_FILES TRACING_QML_RESOURCES)
  get_filename_component(fileName "${file}" NAME)
  set_source_files_properties("${file}" PROPERTIES QT_RESOURCE_ALIAS "${fileName}")
endforeach()

qt_add_shaders(Tracing "res_tracingshaders"
  BATCHABLE
  PREFIX
    "/qt/qml/QtCreator/Tracing"
  BASE
    "qml"
  FILES
    qml/notes_qt6.vert
    qml/notes_qt6.frag
    qml/timelineitems_qt6.vert
    qml/timelineitems_qt6.frag
)

qt_add_qml_module(Tracing
  URI "QtCreator.Tracing"
  VERSION "1.0"
  NO_PLUGIN
  RESOURCE_PREFIX "/qt/qml"
  DEPENDENCIES
    QtQuick
  QML_FILES
    ${TRACING_QML_FILES}
  RESOURCES
    ${TRACING_QML_RESOURCES}
  SOURCES
    ${TRACING_CPP_SOURCES}
)

=== src/plugins/bazaar/CMakeLists.txt ===
add_qtc_plugin(Bazaar
  PLUGIN_DEPENDS Core TextEditor VcsBase
  SOURCES
    annotationhighlighter.cpp annotationhighlighter.h
    bazaarclient.cpp bazaarclient.h
    bazaarcommitwidget.cpp bazaarcommitwidget.h
    bazaareditor.cpp bazaareditor.h
    bazaarplugin.cpp bazaarplugin.h
    bazaarsettings.cpp bazaarsettings.h
    branchinfo.cpp branchinfo.h
    commiteditor.cpp commiteditor.h
    constants.h
    pullorpushdialog.cpp pullorpushdialog.h
)

=== debian/changelog ===
qtcreator (9.0.2-2) unstable; urgency=medium

  * Fix search path for qdoc (Closes: #1031893).
    Thanks Pino Toscano for the help!

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Mon, 27 Feb 2023 13:12:24 -0300

qtcreator (9.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Wed, 22 Feb 2023 19:22:48 +0100

qtcreator (9.0.1-2) unstable; urgency=medium

  * Team upload.
  * Drop the clang-tidy, and clang-tools build dependencies: finally LLVM 14
    was fixed.
  * Update standards version to 4.6.2, no changes needed.

 -- Pino Toscano <pino@debian.org>  Sat, 04 Feb 2023 12:58:56 +0100

=== debian/control ===
--- 
+++ 
@@ -28,10 +28,7 @@
                qt6-quick3d-dev (>= 6.2.4-2~),
                qt6-tools-dev (>= 6.2.4-2~),
                qt6-tools-private-dev (>= 6.2.4-2~),
-# workaround dependency issues in llvm (#1021857)
-               clang-tidy,
-               clang-tools,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://doc.qt.io/qt-5/topics-app-development.html
 Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,16 @@
 archs_with_dwz_low_mem = armel armhf mipsel
 dwz_low_mem = 3000000
 
+archs_using_clang = mips64el mipsel
+ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_using_clang)))
+export CC=clang
+export CXX=clang++
+export DEB_CFLAGS_MAINT_APPEND := -gdwarf-4
+export DEB_CXXFLAGS_MAINT_APPEND := -gdwarf-4
+export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
+EXTRA_CMAKE_ARGS += -DBUILD_WITH_PCH=OFF
+endif
+
 %:
 	dh $@ --builddirectory=builddir
 
@@ -29,7 +39,8 @@
 		-DWITH_TESTS=OFF \
 		-DBUILD_TESTING=OFF \
 		-DCLANGTOOLING_LINK_CLANG_DYLIB=ON \
-		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF)
+		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF) \
+		$(EXTRA_CMAKE_ARGS)
 
 execute_after_dh_auto_build-indep:
 	dh_auto_build -- docs

## qtcreator 10.0.2

=== debian/changelog ===
qtcreator (10.0.2-4) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * Revert the changes done in 10.0.2-2 and 10.0.2-3:
    - first of all, they were uploaded totally untested, unreviewed, as
      "team upload", whereas they were effectively NMUs, as Gianfranco is not
      part of the team
    - the fix-yaml-cpp-search.patch patch is an own creation not forwarded
      upstream
    - the nonsense in dh_auto_clean, i.e. removing cmake/Findyaml-cpp.cmake,
      causes the above patch to even not work at all
  * Backport upstream commit 170f9acfb41704b68e2ba98690fd6d5e98addd85 to find
    yaml-cpp 0.8; patch upstream_ClangTools-Add-support-for-yaml-cpp-0.8.patch.
    (Closes: #1050367)
  * Drop build tweaks for mipsel, as that architecture was recently
    discontinued.
  * Update lintian overrides.

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Update Qt packages listed as build dependencies that have changed their
    name.

 -- Pino Toscano <pino@debian.org>  Sun, 27 Aug 2023 20:45:25 +0200

qtcreator (10.0.2-3) unstable; urgency=medium

  * Team upload.
  * Fix yaml-cpp find and link with a non-retro-compatible patch.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 24 Aug 2023 11:15:57 +0200

qtcreator (10.0.2-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Remove cmake/Findyaml-cpp.cmake for compatibility with the new yaml-cpp
    (Closes: #1050367).

  [ Simon Quigley ]
  * Ack and team upload, thanks Gianfranco!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Aug 2023 19:24:47 -0500

qtcreator (10.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sat, 17 Jun 2023 04:50:32 +0200

qtcreator (10.0.1-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Sun, 11 Jun 2023 21:05:01 +0200

qtcreator (10.0.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sun, 07 May 2023 08:44:11 +0200

qtcreator (10.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Switch watch file back to stable releases.
  * The usage of libdebuginfod seems to have been dropped, so:
    - drop the patch cmake_libdebuginfod.diff, no more needed
    - drop the libdebuginfod-dev build dependency

 -- Pino Toscano <pino@debian.org>  Thu, 30 Mar 2023 08:31:13 +0200

qtcreator (10.0.0~rc1-1) experimental; urgency=medium

  * Team upload.
  * New upstream development release.
  * Update the patches:
    - fix_qdoc_search_patch.patch: drop, fixed upstream

 -- Pino Toscano <pino@debian.org>  Thu, 16 Mar 2023 15:20:39 +0100

qtcreator (10.0.0~beta2-1) experimental; urgency=medium

  * Team upload.
  * New upstream development release.
  * Merge changes from 9.0.2-1, and 9.0.2-2:
    - refresh patch fix_qdoc_search_patch.patch

 -- Pino Toscano <pino@debian.org>  Thu, 02 Mar 2023 16:43:13 +0100

qtcreator (10.0.0~beta1-1) experimental; urgency=medium

  * Team upload.
  * New upstream development release.
  * Switch watch file to the unstable releases.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update the build dependencies according to the upstream build system:
    - add libdebuginfod-dev
  * Properly find the debuginfod library using cmake, to link against it when
    using newer versions of elfutils; patch cmake_libdebuginfod.diff.

 -- Pino Toscano <pino@debian.org>  Sat, 18 Feb 2023 21:12:16 +0100

=== debian/control ===
--- 
+++ 
@@ -10,22 +10,22 @@
                debhelper-compat (= 13),
                libclang-dev (>= 1:10~),
                libdw-dev,
-               libqt6core5compat6-dev (>= 6.2~),
                libqt6opengl6-dev (>= 6.2~),
-               libqt6quicktimeline6-dev (>= 6.2~),
-               libqt6serialport6-dev (>= 6.2~),
-               libqt6shadertools6-dev (>= 6.2.4-2~),
-               libqt6svg6-dev (>= 6.2~),
                libyaml-cpp-dev (>= 0.5~),
                libzstd-dev,
                llvm-dev (>= 1:10~),
                pkg-config,
                python3:any,
+               qt6-5compat-dev (>= 6.2~),
                qt6-base-dev (>= 6.2.4+dfsg-3~),
                qt6-base-private-dev (>= 6.2.4+dfsg-3~),
                qt6-declarative-dev (>= 6.2~),
                qt6-declarative-private-dev (>= 6.2~),
                qt6-quick3d-dev (>= 6.2.4-2~),
+               qt6-quicktimeline-dev (>= 6.2~),
+               qt6-serialport-dev (>= 6.2~),
+               qt6-shadertools-dev (>= 6.2.4-2~),
+               qt6-svg-dev (>= 6.2~),
                qt6-tools-dev (>= 6.2.4-2~),
                qt6-tools-private-dev (>= 6.2.4-2~),
 Standards-Version: 4.6.2
